<?php

/**
 * @package Pastebin BBC mod
 * @version 1.0
 * @author Jessica Gonzlez <missallsunday@simplemachines.org>
 * @copyright Copyright (c) 2011, Jessica Gonzlez
 * @license http://www.mozilla.org/MPL/MPL-1.1.html
 */

/*
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is http://missallsunday.com code.
 *
 * The Initial Developer of the Original Code is
 * Jessica Gonzlez.
 * Portions created by the Initial Developer are Copyright (C) 2011
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 */

if (!defined('SMF'))
	die('Hacking attempt...');

	 /* The bbc button */
	function PbBBC_bbc_add_button($buttons){

		global $txt, $modSettings;

		loadLanguage('PastebinBBC');

		$cURL = I_can_has_cURL();

		if ($cURL == false && empty($modSettings['PbBBC_master']) || empty($modSettings['PbBBC_dev_api_key']))
			return;

			$buttons[count($buttons) - 1][] = array(
				'image' => 'pastebin',
				'code' => 'pastebin',
				'before' => '[pastebin=text]',
				'after' => '[/pastebin]',
				'description' => $txt['PbBBC_desc'],
			);
	}

	/* Don't bother on create a whole new page for this, let's use integrate_general_mod_settings ^o^ */
	function PbBBC_settings(&$config_vars)
	{
		global $txt;

		loadLanguage('PastebinBBC');

		/* hackish... I know, I KNOW!!! */
		$title = I_can_has_cURL() ? $txt['PbBBC_title'] : $txt['PbBBC_no_curl'];

		$config_vars[] = $title;
		$config_vars[] = array('check', 'PbBBC_master', 'subtext' => $txt['PbBBC_master_sub']);
		$config_vars[] = array('text', 'PbBBC_dev_api_key', 'subtext' => $txt['PbBBC_dev_api_key_sub'], 'size' => 35);
		$config_vars[] = array(
			'select',
			'PbBBC_expire_date', array(
				'10M' => $txt['PbBBC_expire_date_minute'],
				'1H' => $txt['PbBBC_expire_date_hour'],
				'1D' => $txt['PbBBC_expire_date_day'],
				'1M' => $txt['PbBBC_expire_date_month']
			)
		);
		$config_vars[] = '';
	}

	/* Take the data, send it to pastebin and return the link, two parameters, the data itself and the name/language */
	function PbBBC_Main($data)
	{
		/* Regex to capture all the pastebin tags */
		$PbBBC_regex = '/\[pastebin=(.*?)\](.*?)\[\/pastebin\]/s';
		$big_array = array();

		/* I can has cURL? */
		if (I_can_has_cURL())
		{
			if (preg_match_all($PbBBC_regex, $data, $matches))
			{
				$n= 0;

				foreach ($matches[0] as $full_code)
				{
					$big_array[$n][1] = $full_code;
					$n++;
				}

				$n= 0;

				foreach ($matches[1] as $key)
				{
					$big_array[$n][2] = $key;
					$n++;
				}

				$n= 0;

				foreach ($matches[2] as $content)
				{
					$big_array[$n][3] = $content;
					$n++;
				}

				foreach ($big_array as $part)
					$data = str_replace($part[1], PbBBC_cURL($part[3], $part[2]), $data);

				return $data;
			}

			else
			return $data;
		}

		else
			return $data;
	}

	function PbBBC_cURL($data, $key)
	{
		global $modSettings, $txt;

		loadLanguage('PastebinBBC');

		/* All possible values for the format...  who write stuff in Modula 2 anyway...*/
		$api_paste_format_array = array(
			'4cs', '6502acme','6502kickass','6502tasm','abap','actionscript','actionscript3','ada','algol68','apache','applescript','apt_sources','asm','asp','autoconf','autohotkey','autoit','avisynth','awk','bascomavr','bash','basic4gl','bibtex','blitzbasic','bnf','boo','bf','BrainFuck','c','c_mac','cil','cshar','cpp','cpp-qt','c_loadrunner','caddcl','cadlisp','cfdg','chaiscript','clojure','klonec','klonecpp','cmake','cobol','coffeescript','cfm','css','cuesheet','d','dcs','delphi','oxygene','diff','div','dos','dot','e','ecmascript','eiffel','email','epc','erlang','fsharp','falcon','fo','f1','fortran','freebasic','gambas','gml','gdb','genero','genie','gettext','go','groovy','gwbasic','haskell','hicest','hq9plus','html4strict','html5','icon','idl','ini','inno','intercal','io','j','java','java5','javascript','jquery','kixtart','latex','lb','lsl2','lisp','llvm','locobasic','logtalk','lolcode','lotusformulas','lotusscript','lscript','lua','m68k','magiksf','make','mapbasic','matlab','mirc','mmix','modula2','modula3','68000devpac','mpasm','mxml','mysql','newlisp','text','nsis','oberon2','objeck','objc','ocaml-brief','ocaml','pf','glsl','oobas','oracle11','oracle8','oz','pascal','pawn','pcre','per','perl','perl6','php','php-brief','pic16','pike','pixelbender','plsql','postgresql','povray','powershell','powerbuilder','proftpd','progress','prolog','properties','providex','purebasic','pycon','python','q','qbasic','rsplus','rails','rebol','reg','robots','rpmspec','ruby','gnuplot','sas','scala','scheme','scilab','sdlbasic','smalltalk','smarty','sql','systemverilog','tsql','tcl','teraterm','thinbasic','typoscript','unicon','uscript','vala','vbnet','verilog','vhdl','vim','visualprolog','vb','visualfoxpro','whitespace','whois','winbatch','xbasic','xml','xorg_conf','xpp','yaml','z80','zxbasic'
		);

		/* Set some variables */
		$api_dev_key = empty($modSettings['PbBBC_dev_api_key']) ? '' : $modSettings['PbBBC_dev_api_key'];
		$api_paste_code = $data;
		$api_paste_private = '0';
		$api_paste_name = in_array($key, $api_paste_format_array) ? $key : 'text';
		$api_paste_expire_date = empty($modSettings['PbBBC_expire_date']) ? '1M' : $modSettings['PbBBC_expire_date'];
		$api_paste_format = in_array($key, $api_paste_format_array) ? $key : 'text';
		$api_user_key = '';
		$api_paste_name = urlencode($api_paste_name);
		$api_paste_code = urlencode($api_paste_code);
		$url = 'http://pastebin.com/api/api_post.php';
		$regex = '/Bad/';

		$ch = curl_init($url);

			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, 'api_option=paste&api_user_key='.$api_user_key.'&api_paste_private='.$api_paste_private.'&api_paste_name='.$api_paste_name.'&api_paste_expire_date='.$api_paste_expire_date.'&api_paste_format='.$api_paste_format.'&api_dev_key='.$api_dev_key.'&api_paste_code='.$api_paste_code.'');
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
			curl_setopt($ch, CURLOPT_NOBODY, 0);

			$response = curl_exec($ch);
			curl_close($ch);

			/* Pastebin says this is a bad API response */
			if (preg_match($regex, $response))
				return sprintf($txt['PbBBC_error'], $response);

			else
				return sprintf($txt['PbBBC_ok'],$response);
	}

	function PbBBC_who(){

		$MAS = '<a href="http://missallsunday.com" title="Free SMF Mods">Pastebin BBC mod &#169; Suki</a>';

		return $MAS;
	}

	function I_can_has_cURL()
	{
		if (function_exists('curl_init'))
			return true;

		else
			return false;
	}

	/* I guess I just figured,
	why make something disposable like a building
	when you can make something that last forever,
	like a greeting card. */
